function [dw, db] = bp(z, w, m, y, t)
h = length(m)-2;
dw = zeros(size(w));% derivatives of all weights
db = zeros(h+1, max(m));

db(h+1, 1:m(h+2)) = (1-y) .* y .* (y-t);
for j=1:m(h+2)
    dw(h+1, (1:m(h+1)), j) = z(h+1, (1:m(h+1))) * db(h+1, j);
end

for l=h:-1:1
    for j=1:m(l+1)
        db(l,j) = (1-z(l+1,j)) * sum(dw(l+1,j,(1:m(l+2))).*w(l+1,j,(1:m(l+2))));
        dw(l,(1:m(l)),j) = z(l,(1:m(l))) * db(l,j);
    end
end