function [dw, db] = bp(z, w, m, y, t)
h = length(m) - 2;
dw = zeros(size(w));    % derivatives of all weights
db = zeros(h+1, max(m));% derivatives of all biases

for j=1:m(h+2)
    if y(j)>0
        db(h+1,j) = y(j) - t(j);
        dw(h+1,(1:m(h+1)),j) = z(h+1,(1:m(h+1))) * db(h+1,j);
    end
end

for l=h:-1:1
    for j=1:m(l+1)
        if z(l+1,j)>0
            tmp = reshape(w(l+1,j,(1:m(l+2))), [1,m(l+2)]);
            db(l,j) = sum(db(l+1,(1:m(l+2))).*tmp);
            dw(l,(1:m(l)),j) = z(l,(1:m(l))) * db(l,j);
        end
    end
end